/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.93 Revision 1.113
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.93 2011/05/23 22:56:36 abcd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.113 2012/03/06 22:23:51 dilfridge Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# over time as new EAPI versions are approved. 14# over time as new EAPI versions are approved.
15
16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
15 22
16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED 23# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION: 24# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage. 25# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx 26# Here we redefine default value to be manual, if your package needs virtualx
39if [[ ${CMAKE_REQUIRED} = always ]]; then 46if [[ ${CMAKE_REQUIRED} = always ]]; then
40 buildsystem_eclass="cmake-utils" 47 buildsystem_eclass="cmake-utils"
41 export_fns="src_configure src_compile src_test src_install" 48 export_fns="src_configure src_compile src_test src_install"
42fi 49fi
43 50
44# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
45if [[ -n ${KDE_MINIMAL} ]]; then
46 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
47 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
48 done
49 unset slot
50 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
51else
52 KDE_MINIMAL_VALID=1
53fi
54
55# @ECLASS-VARIABLE: KDE_MINIMAL 51# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION: 52# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal 53# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4 54# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements. 55# One may override this variable to raise version requirements.
60# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
61# Note that it is fixed to ${SLOT} for kde-base packages. 56# Note that it is fixed to ${PV} for kde-base packages.
62KDE_MINIMAL="${KDE_MINIMAL:-4.4}" 57KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
63 58
64# Set slot for KDEBASE known packages 59# Set slot for KDEBASE known packages
65case ${KDEBASE} in 60case ${KDEBASE} in
66 kde-base) 61 kde-base)
67 SLOT=$(_calculate_kde_slot) 62 SLOT=4
68 [[ -z ${SLOT} ]] && die "Unsupported ${PV}"
69 KDE_MINIMAL="${SLOT}" 63 KDE_MINIMAL="${PV}"
70 ;; 64 ;;
71 koffice) 65 koffice)
72 SLOT="2" 66 SLOT="2"
73 ;; 67 ;;
74 kdevelop) 68 kdevelop)
87 case ${PN} in 81 case ${PN} in
88 kdevelop|quanta) 82 kdevelop|quanta)
89 KDEVELOP_VERSION=${PV} 83 KDEVELOP_VERSION=${PV}
90 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)" 84 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
91 ;; 85 ;;
92 kdevplatform) 86 kdevplatform|kdevelop-php*)
93 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)" 87 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
94 KDEVPLATFORM_VERSION=${PV} 88 KDEVPLATFORM_VERSION=${PV}
95 ;; 89 ;;
96 *) 90 *)
97 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}" 91 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
131# @DESCRIPTION: 125# @DESCRIPTION:
132# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'. 126# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'never'. 127# This variable must be set before inheriting any eclasses. Defaults to 'never'.
134MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}" 128MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
135 129
136# @ECLASS-VARIABLE: WEBKIT_REQUIRED
137# @DESCRIPTION:
138# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
139# This variable must be set before inheriting any eclasses. Defaults to 'never'.
140WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
141
142# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 130# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
143# @DESCRIPTION: 131# @DESCRIPTION:
144# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 132# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
145# This variable must be set before inheriting any eclasses. Defaults to 'never'. 133# This variable must be set before inheriting any eclasses. Defaults to 'never'.
146CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 134CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
179 HOMEPAGE="http://www.kde.org/" 167 HOMEPAGE="http://www.kde.org/"
180 LICENSE="GPL-2" 168 LICENSE="GPL-2"
181 if [[ $BUILD_TYPE = live ]]; then 169 if [[ $BUILD_TYPE = live ]]; then
182 # Disable tests for live ebuilds 170 # Disable tests for live ebuilds
183 RESTRICT+=" test" 171 RESTRICT+=" test"
184 # Live ebuilds in kde-base default to kdeprefix by default 172 fi
185 IUSE+=" +kdeprefix" 173
186 else 174 # Only add the kdeprefix USE flag for older versions, to help
187 # All other ebuild types default to -kdeprefix as before 175 # non-portage package managers handle the upgrade
176 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
188 IUSE+=" kdeprefix" 177 IUSE+=" kdeprefix"
189 fi 178 fi
179
190 # This code is to prevent portage from searching GENTOO_MIRRORS for 180 # This code is to prevent portage from searching GENTOO_MIRRORS for
191 # packages that will never be mirrored. (As they only will ever be in 181 # packages that will never be mirrored. (As they only will ever be in
192 # the overlay). 182 # the overlay).
193 case ${PV} in 183 case ${PV} in
194 *9999* | 4.?.[6-9]?) 184 *9999* | 4.?.[6-9]?)
195 RESTRICT+=" mirror" 185 RESTRICT+=" mirror"
196 ;; 186 ;;
197 esac 187 esac
198 # Block installation of other SLOTS unless kdeprefix
199 RDEPEND+=" $(block_other_slots)"
200 ;; 188 ;;
201 koffice) 189 koffice)
202 HOMEPAGE="http://www.koffice.org/" 190 HOMEPAGE="http://www.koffice.org/"
203 LICENSE="GPL-2" 191 LICENSE="GPL-2"
204 ;; 192 ;;
209esac 197esac
210 198
211# @ECLASS-VARIABLE: QT_MINIMAL 199# @ECLASS-VARIABLE: QT_MINIMAL
212# @DESCRIPTION: 200# @DESCRIPTION:
213# Determine version of qt we enforce as minimal for the package. 201# Determine version of qt we enforce as minimal for the package.
214if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then 202if version_is_at_least 4.8.50 "${KDE_MINIMAL}"; then
203 # Upstream has added an *undeclared* dependency on Qt 4.8...
204 QT_MINIMAL="${QT_MINIMAL:-4.8.0}"
205elif version_is_at_least 4.7.80 "${KDE_MINIMAL}"; then
206 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
207else
215 QT_MINIMAL="${QT_MINIMAL:-4.7.0}" 208 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
216else
217 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
218fi 209fi
219 210
220# Declarative dependencies 211# Declarative dependencies
221qtdeclarativedepend=" 212qtdeclarativedepend="
222 >=x11-libs/qt-declarative-${QT_MINIMAL}:4 213 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
278 ;; 269 ;;
279 *) ;; 270 *) ;;
280esac 271esac
281unset qtmultimediadepend 272unset qtmultimediadepend
282 273
283# WebKit dependencies
284case ${KDE_REQUIRED} in
285 always)
286 qtwebkitusedeps="[kde]"
287 ;;
288 optional)
289 qtwebkitusedeps="[kde?]"
290 ;;
291 *) ;;
292esac
293qtwebkitdepend="
294 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
295"
296unset qtwebkitusedeps
297case ${WEBKIT_REQUIRED} in
298 always)
299 COMMONDEPEND+=" ${qtwebkitdepend}"
300 ;;
301 optional)
302 IUSE+=" webkit"
303 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
304 ;;
305 *) ;;
306esac
307unset qtwebkitdepend
308
309# CppUnit dependencies 274# CppUnit dependencies
310cppuintdepend=" 275cppuintdepend="
311 dev-util/cppunit 276 dev-util/cppunit
312" 277"
313case ${CPPUNIT_REQUIRED} in 278case ${CPPUNIT_REQUIRED} in
326# Qt accessibility classes are needed in various places, bug 325461 291# Qt accessibility classes are needed in various places, bug 325461
327kdecommondepend=" 292kdecommondepend="
328 dev-lang/perl 293 dev-lang/perl
329 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 294 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
330 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 295 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
331 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde] 296 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility]
332 >=x11-libs/qt-script-${QT_MINIMAL}:4 297 >=x11-libs/qt-script-${QT_MINIMAL}:4
333 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 298 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
334 >=x11-libs/qt-svg-${QT_MINIMAL}:4 299 >=x11-libs/qt-svg-${QT_MINIMAL}:4
335 >=x11-libs/qt-test-${QT_MINIMAL}:4 300 >=x11-libs/qt-test-${QT_MINIMAL}:4
301 >=x11-libs/qt-webkit-${QT_MINIMAL}:4
336 !aqua? ( 302 !aqua? (
337 x11-libs/libXext 303 x11-libs/libXext
338 x11-libs/libXt 304 x11-libs/libXt
339 x11-libs/libXxf86vm 305 x11-libs/libXxf86vm
340 x11-libs/libXcomposite 306 x11-libs/libXcomposite
307 x11-libs/libxkbfile
341 ) 308 )
342" 309"
343 310
344if [[ ${PN} != kdelibs ]]; then 311if [[ ${PN} != kdelibs ]]; then
345 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 312 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
411 ;; 378 ;;
412 *) ;; 379 *) ;;
413esac 380esac
414unset kdehandbookdepend kdehandbookrdepend 381unset kdehandbookdepend kdehandbookrdepend
415 382
383case ${KDE_SELINUX_MODULE} in
384 none) ;;
385 *)
386 IUSE+=" selinux"
387 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
388 ;;
389esac
390
416case ${KDE_REQUIRED} in 391case ${KDE_REQUIRED} in
417 always) 392 always)
418 IUSE+=" aqua" 393 IUSE+=" aqua"
419 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}" 394 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
420 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}" 395 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
437 412
438# Accumulate dependencies set by this eclass 413# Accumulate dependencies set by this eclass
439DEPEND+=" ${COMMONDEPEND}" 414DEPEND+=" ${COMMONDEPEND}"
440RDEPEND+=" ${COMMONDEPEND}" 415RDEPEND+=" ${COMMONDEPEND}"
441unset COMMONDEPEND 416unset COMMONDEPEND
442
443# Add experimental kdeenablefinal, masked by default
444IUSE+=" kdeenablefinal"
445 417
446# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 418# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
447# koffice ebuild, the URI should be set in the ebuild itself 419# koffice ebuild, the URI should be set in the ebuild itself
448_calculate_src_uri() { 420_calculate_src_uri() {
449 debug-print-function ${FUNCNAME} "$@" 421 debug-print-function ${FUNCNAME} "$@"
467 fi 439 fi
468 _kmname_pv="${_kmname}-${PV}" 440 _kmname_pv="${_kmname}-${PV}"
469 case ${KDEBASE} in 441 case ${KDEBASE} in
470 kde-base) 442 kde-base)
471 case ${PV} in 443 case ${PV} in
444 4.4.11.1)
445 # KDEPIM 4.4, special case
446 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
447 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
472 4.[456].8[05] | 4.[456].9[023568]) 448 4.[456789].8[05] | 4.[456789].9[0235678])
473 # Unstable KDE SC releases 449 # Unstable KDE SC releases
474 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" 450 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
475 # KDEPIM IS SPECIAL 451 4.8.1)
476 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2" 452 # Stable KDE SC releases with .xz support
477 ;;
478 4.4.[6789] | 4.4.1?*)
479 # Stable kdepim releases
480 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" 453 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
481 ;;
482 *) 454 *)
483 # Stable KDE SC releases 455 # Stable KDE SC releases
484 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" 456 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
485 ;;
486 esac 457 esac
487 ;; 458 ;;
488 koffice) 459 koffice)
489 case ${PV} in 460 case ${PV} in
490 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 461 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
491 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 462 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
492 esac 463 esac
493 ;; 464 ;;
494 kdevelop) 465 kdevelop|kdevelop-php*|kdevplatform)
466 case ${KDEVELOP_VERSION} in
467 4.[12].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
495 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" 468 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
469 esac
496 ;; 470 ;;
497 esac 471 esac
498} 472}
499 473
500_calculate_live_repo() { 474_calculate_live_repo() {
510 # trunk 484 # trunk
511 branch_prefix="trunk/KDE" 485 branch_prefix="trunk/KDE"
512 ;; 486 ;;
513 *) 487 *)
514 # branch 488 # branch
515 branch_prefix="branches/KDE/${SLOT}" 489 branch_prefix="branches/KDE/$(get_kde_version)"
516 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX 490 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
517 # @DESCRIPTION 491 # @DESCRIPTION
518 # Suffix appended to ESVN_PROJECT depending on fetched branch. 492 # Suffix appended to ESVN_PROJECT depending on fetched branch.
519 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise. 493 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
520 ESVN_PROJECT_SUFFIX="-${PV}" 494 ESVN_PROJECT_SUFFIX="-${PV}"
594 else 568 else
595 _kmname=${PN} 569 _kmname=${PN}
596 fi 570 fi
597 571
598 # default branching 572 # default branching
599 case ${PV} in 573 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
600 9999*) ;; 574 EGIT_BRANCH="KDE/$(get_kde_version)"
601 *)
602 # set EGIT_BRANCH and EGIT_COMMIT to ${SLOT}
603 case ${_kmname} in
604 kdeplasma-addons | kdepim | kdepim-runtime | kdepimlibs)
605 EGIT_BRANCH="${SLOT}"
606 ;;
607 *) EGIT_BRANCH="KDE/${SLOT}" ;;
608 esac
609 ;;
610 esac
611 575
576 # default repo uri
612 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}" 577 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
613 578
614 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}" 579 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
615 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}" 580 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
616 ;; 581 ;;
625debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 590debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
626 591
627# @ECLASS-VARIABLE: PREFIX 592# @ECLASS-VARIABLE: PREFIX
628# @DESCRIPTION: 593# @DESCRIPTION:
629# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 594# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
630# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 595# kde-base packages go into KDE4 installation directory (/usr).
631# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 596# No matter the PREFIX, package will be built against KDE installed in /usr.
632 597
633# @FUNCTION: kde4-base_pkg_setup 598# @FUNCTION: kde4-base_pkg_setup
634# @DESCRIPTION: 599# @DESCRIPTION:
635# Do the basic kdeprefix KDEDIR settings and determine with which kde should 600# Do some basic settings
636# optional applications link
637kde4-base_pkg_setup() { 601kde4-base_pkg_setup() {
638 debug-print-function ${FUNCNAME} "$@" 602 debug-print-function ${FUNCNAME} "$@"
639 603
640 # QA ebuilds 604 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
641 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})." 605 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
606 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
607 fi
608
609 if use_if_iuse kdeprefix; then
610 eerror "Sorry, kdeprefix support has been removed."
611 eerror "Please remove kdeprefix from your USE variable."
612 die "kdeprefix support has been removed"
613 fi
614
615 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
616 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
617 has_version kde-base/kdelibs[kdeprefix]; then
618 eerror "Sorry, kdeprefix support has been removed."
619 eerror "Please rebuild kdelibs without kdeprefix support."
620 die "kdeprefix support has been removed"
621 fi
642 622
643 # Don't set KDEHOME during compilation, it will cause access violations 623 # Don't set KDEHOME during compilation, it will cause access violations
644 unset KDEHOME 624 unset KDEHOME
645 625
646 # Check if gcc compiler is fresh enough. 626 # Check if gcc compiler is fresh enough.
647 # In theory should be in pkg_pretend but we check it only for kdelibs there 627 # In theory should be in pkg_pretend but we check it only for kdelibs there
648 # and for others we do just quick scan in pkg_setup because pkg_pretend 628 # and for others we do just quick scan in pkg_setup because pkg_pretend
649 # executions consume quite some time. 629 # executions consume quite some time.
630 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
631 # is otherwise undefined.
632 if [[ ${EAPI:-0} != 3 ]]; then
633 if [[ ${MERGE_TYPE} != binary ]]; then
650 [[ $(gcc-major-version) -lt 4 ]] || \ 634 [[ $(gcc-major-version) -lt 4 ]] || \
651 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \ 635 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
652 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)." 636 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
653
654 if [[ ${KDEBASE} = kde-base ]]; then
655 if use kdeprefix; then
656 KDEDIR=/usr/kde/${SLOT}
657 else
658 KDEDIR=/usr
659 fi 637 fi
660 : ${PREFIX:=${KDEDIR}}
661 else
662 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
663 KDEDIR=
664 local kde_minimal_met
665 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
666 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
667 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
668 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
669 KDEDIR=/usr/kde/${slot}
670 else
671 KDEDIR=/usr
672 fi
673 break;
674 fi
675 done
676 unset slot
677
678 # Bail out if kdelibs required but not found
679 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
680 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
681 else
682 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
683 fi 638 fi
684 639
640 KDEDIR=/usr
685 : ${PREFIX:=/usr} 641 : ${PREFIX:=/usr}
686 fi 642 EKDEDIR=${EPREFIX}/usr
687 EKDEDIR=${EPREFIX}${KDEDIR}
688 643
689 # Point pkg-config path to KDE *.pc files
690 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
691 # Point to correct QT plugins path 644 # Point to correct QT plugins path
692 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/" 645 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
693 646
694 # Fix XDG collision with sandbox 647 # Fix XDG collision with sandbox
695 export XDG_CONFIG_HOME="${T}" 648 export XDG_CONFIG_HOME="${T}"
696} 649}
697 650
733 fi 686 fi
734 687
735 # Enable/disable handbooks for kde4-base packages 688 # Enable/disable handbooks for kde4-base packages
736 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 689 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
737 # kdelibs inherits kde4-base but handle installing the handbook itself 690 # kdelibs inherits kde4-base but handle installing the handbook itself
738 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then 691 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
739 if [[ ${KDEBASE} == kde-base ]]; then 692 if [[ ${KDEBASE} == kde-base ]]; then
740 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then 693 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
741 # documentation in kde4-functions 694 # documentation in kde4-functions
742 : ${KDE_DOC_DIRS:=doc} 695 : ${KDE_DOC_DIRS:=doc}
743 local dir 696 local dir
772 # Inject library dependencies 725 # Inject library dependencies
773 if [[ -n ${KMLOADLIBS} ]] ; then 726 if [[ -n ${KMLOADLIBS} ]] ; then
774 load_library_dependencies 727 load_library_dependencies
775 fi 728 fi
776 729
777 # Replace KDE4Workspace library targets
778 find "${S}" -name CMakeLists.txt \
779 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
780 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
781 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
782 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
783 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
784 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
785 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
786 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
787 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
788 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
789 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
790 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
791 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
792 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
793 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
794 || die 'failed to replace KDE4Workspace library targets'
795
796 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/... 730 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
797 if [[ -z ${KDEBASE} ]]; then 731 if [[ -z ${KDEBASE} ]]; then
798 find "${S}" -name "*.docbook" \ 732 find "${S}" -name "*.docbook" \
799 -exec sed -i -r \ 733 -exec sed -i -r \
800 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \ 734 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
809 debug-print-function ${FUNCNAME} "$@" 743 debug-print-function ${FUNCNAME} "$@"
810 744
811 # Build tests in src_test only, where we override this value 745 # Build tests in src_test only, where we override this value
812 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF) 746 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
813 747
814 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then 748 if use_if_iuse debug; then
815 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
816 fi
817
818 if has debug ${IUSE//+} && use debug; then
819 # Set "real" debug mode 749 # Set "real" debug mode
820 CMAKE_BUILD_TYPE="Debugfull" 750 CMAKE_BUILD_TYPE="Debugfull"
821 else 751 else
822 # Handle common release builds 752 # Handle common release builds
823 append-cppflags -DQT_NO_DEBUG 753 append-cppflags -DQT_NO_DEBUG
830 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}") 760 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
831 761
832 # Use colors 762 # Use colors
833 QTEST_COLORED=1 763 QTEST_COLORED=1
834 764
835 # Shadow existing /usr installations 765 # Shadow existing installations
836 unset KDEDIRS 766 unset KDEDIRS
837 767
838 # Handle kdeprefix-ed KDE
839 if [[ ${KDEDIR} != /usr ]]; then
840 # Override some environment variables - only when kdeprefix is different,
841 # to not break ccache/distcc
842 PATH="${EKDEDIR}/bin:${PATH}"
843
844 # Append library search path
845 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
846
847 # Append full RPATH
848 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
849
850 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
851 # when more are present
852 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
853 fi
854
855 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling 768 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
856 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4) 769 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
857 #kde-config -path data unavailable when cross-compiling 770 #kde-config -path data unavailable when cross-compiling
858 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/) 771 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
859 772
860 # Handle kdeprefix in application itself
861 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
862 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 773 # sysconf needs to be /etc, not /usr/etc
863 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc) 774 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
864 fi
865 775
866 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then 776 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
867 mycmakeargs=(${mycmakeargs}) 777 mycmakeargs=(${mycmakeargs})
868 fi 778 fi
869 779
949# Function storing icon caches 859# Function storing icon caches
950kde4-base_pkg_preinst() { 860kde4-base_pkg_preinst() {
951 debug-print-function ${FUNCNAME} "$@" 861 debug-print-function ${FUNCNAME} "$@"
952 862
953 gnome2_icon_savelist 863 gnome2_icon_savelist
864 if [[ ${BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
865 subversion_pkg_preinst
866 fi
954} 867}
955 868
956# @FUNCTION: kde4-base_pkg_postinst 869# @FUNCTION: kde4-base_pkg_postinst
957# @DESCRIPTION: 870# @DESCRIPTION:
958# Function to rebuild the KDE System Configuration Cache after an application has been installed. 871# Function to rebuild the KDE System Configuration Cache after an application has been installed.
963 fdo-mime_desktop_database_update 876 fdo-mime_desktop_database_update
964 fdo-mime_mime_database_update 877 fdo-mime_mime_database_update
965 buildsycoca 878 buildsycoca
966 879
967 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 880 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
968 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
969 echo
970 ewarn "WARNING! you have kdeenable final useflag enabled."
971 ewarn "This useflag needs to be enabled on ALL kde using packages and"
972 ewarn "is known to cause issues."
973 ewarn "You are using this setup at your own risk and the kde team does not"
974 ewarn "take responsibilities for dead kittens."
975 echo
976 fi
977 if [[ ${BUILD_TYPE} = live ]]; then 881 if [[ ${BUILD_TYPE} = live ]]; then
978 echo 882 echo
979 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}" 883 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
980 einfo "Use it at your own risk." 884 einfo "Use it at your own risk."
981 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!" 885 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
992 ewarn "With this setting you are unsupported by KDE team." 896 ewarn "With this setting you are unsupported by KDE team."
993 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID." 897 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
994 fi 898 fi
995 fi 899 fi
996 fi 900 fi
997 if has kdeprefix ${IUSE//+} && use kdeprefix; then
998 # warning about kdeprefix
999 echo
1000 ewarn "WARNING! You have the kdeprefix useflag enabled."
1001 eerror "This setting will be removed on or about 2011-06-06."
1002 ewarn "You are using this setup at your own risk and the kde team does not"
1003 ewarn "take responsibilities for dead kittens."
1004 echo
1005 fi
1006} 901}
1007 902
1008# @FUNCTION: kde4-base_pkg_postrm 903# @FUNCTION: kde4-base_pkg_postrm
1009# @DESCRIPTION: 904# @DESCRIPTION:
1010# Function to rebuild the KDE System Configuration Cache after an application has been removed. 905# Function to rebuild the KDE System Configuration Cache after an application has been removed.

Legend:
Removed from v.1.93  
changed lines
  Added in v.1.113

  ViewVC Help
Powered by ViewVC 1.1.20